#include <bits/stdc++.h>
using namespace std;
int dec(int a)
{
    return a%2;
}
int main()
{
    cin.tie(0);
    int n,ans;
    int q,t,k,x,y;
    cin>>n;
    vector<int>a(n);
    vector<int>b(32,0),c(32);
    c[0]=1;
    for(int i=1;i<32;i++)
    {
        c[i]=2*c[i-1];
    }


    for(int i=0;i<n;i++)
    {
        cin>>a[i];
        x=a[i];
        for(int j=0;j<32;j++)
        {
         if(dec(x))b[j]++;
         x=x/2;
        }
    }
    cin>>q;
    while(q--)
    {
        cin>>t;
        if(t==0)
        {
            ans=0;
            cin>>k;
            for(int i=0;i<32;i++)
            {
                if(b[i]>=k)
                    ans+=c[i];
            }
            cout<<ans<<endl;
        }
        if(t==1)
        {
            cin>>k>>x;
            y=x;
            for(int i=0;i<32;i++)
            {
                if((dec(a[k-1])) and !(dec(y)))b[i]--;
                if(!(dec(a[k-1])) and (dec(y)))b[i]++;
                y=y/2;
                a[k-1]=a[k-1]/2;
            }
            a[k-1]=x;
        }
    }
    return 0;
}